# Contributing

## Installing

1. Fork the repo
1. clone the repo locally
1. install the dependencies
```
npm install react
npm install react-dom
npm install
```
1. build the application `npm run build`
1. run the example `npm run example`


## How to add a new feature or fix a bug

1. check out a new branch `git checkout -b <your_branch_name>`
1. Write your code and tests
1. Open a pull request following our pull request template
1. The pull request should meet these standards
    - Code coverage remains at least as high as it was when you started.
    - Add necessary documentation.
    - Tests all pass.
    - The dependencies remain up to date.
1. Code will be reviewed before being merged. Code will not be reviewed until all checks pass

## How to open a new issue

1. Ensure the bug was not already reported by searching on GitHub under Issues.
1. Follow the issue template
